/* Copyright (C) Hao Shi 2014 */

#ifndef BREAKPOINT_H_
#define BREAKPOINT_H_

#include <string>
#include <unordered_map>
#include <dbgeng.h>

class DebugBreakpoint {
 public:
  IDebugBreakpoint* m_breakpoint;
        std::string m_description;
};

class BreakpointEx {
 public:
  explicit
  BreakpointEx():
    m_breakpoint_id(8000) {
  }
  ~BreakpointEx() {
  }

  //--------------------------------------------------------------------------
  // Utility routines
  //--------------------------------------------------------------------------
  HRESULT AddBreakpointExpr(IDebugControl* control,
			    _In_ PCSTR Expr,
			    _In_ const char* description);
  ULONG AddBreakpointOffset(IDebugControl* control,
			    _In_ const ULONG64& offset,
			    _In_ const ULONG& beakpoint_type,
			    const char* description);
  HRESULT GetBpDescription(const ULONG& id, std::string* description);

  HRESULT RemoveBreakpoint(IDebugControl* control, const ULONG& id);

  ULONG64 GetBreakpointAddress(const ULONG& id);

  ULONG GetBreakpointId(const ULONG64& address);

  void DisableBreakpoint(const ULONG& id);
  void EnableBreakpoint(const ULONG& id);
  
 private:
  ULONG GetNextBreakpointExId();

  typedef std::unordered_map<ULONG, DebugBreakpoint*> IdBpMap;
  IdBpMap m_id_bp_map;
  ULONG m_breakpoint_id;
};


#endif  // BREAKPOINT_H_


