/* Copyright (C) 2014 Hao Shi */
#include "client_state.h"
#include <sstream>

std::string
ClientState::Format(void) {
  std::stringstream output;
  // registers first
  output << std::hex << m_eax << ';'
	 << std::hex << m_ecx << ';'
	 << std::hex << m_edx << ';'
	 << std::hex << m_ebx << ';'
	 << std::hex << m_esp << ';'
	 << std::hex << m_ebp << ';'
	 << std::hex << m_esi << ';'
    	 << std::hex << m_edi << ';'
	 << std::hex << m_efl << ';'
	 << std::hex << m_ES << ';'
    	 << std::hex << m_CS << ';'
    	 << std::hex << m_SS << ';'
    	 << std::hex << m_DS << ';'
    	 << std::hex << m_FS << ';'
    	 << std::hex << m_GS << ';'
    ;
  output << m_delimiter;  // stack content
  for (auto it = m_stack.begin(); it != m_stack.end(); ++it) {
    output << std::hex << *it << ';';
  }

  output << m_delimiter;  // memory start address
  output << std::hex << m_memory_start_address;
  
  output << m_delimiter;  // memory content
  for (auto it = m_memory.begin(); it != m_memory.end(); ++it) {
    output << std::hex << *it << ';';
  }
  
  return output.str();
}
