/* Copyright (C) 2014 Hao Shi */
#ifndef STATE_H_
#define STATE_H_

#include <windows.h>
#include <vector>
#include <string>

const int MEM_SIZE = 36;

class ClientState {
 public:
  ClientState() {
  }
  // registers
  DWORD m_eax;
  DWORD m_ecx;
  DWORD m_edx;
  DWORD m_ebx;
  DWORD m_esp;
  DWORD m_ebp;
  DWORD m_esi;
  DWORD m_edi;
  DWORD m_efl;
  
  DWORD m_ES;
  DWORD m_CS;
  DWORD m_SS;
  DWORD m_DS;
  DWORD m_FS;
  DWORD m_GS;

  std::vector<DWORD> m_stack;  // statck content, 15 DWORD by default

  ULONG64 m_memory_start_address;
  std::vector<DWORD> m_memory;  // memory content, 20 DWORD by default

  // output function
  std::string Format(void);

 private:
  char m_delimiter = '\t';
};

#endif  // STATE_H_
