/* Copyright (C) Hao Shi 2014 */
#ifndef EVENT_CALLBACKS_H_
#define EVENT_CALLBACKS_H_

#include <dbgeng.h>
#include <fstream>

class EventCallbacks : public DebugBaseEventCallbacks {
 public:
  // IUnknown.
  STDMETHOD_(ULONG, AddRef)(
    THIS
    );
  STDMETHOD_(ULONG, Release)(
    THIS
    );

  // IDebugEventCallbacks.
  STDMETHOD(GetInterestMask)(
    THIS_
    _Out_ PULONG mask
    );
  STDMETHOD(Breakpoint)(
    THIS_
    _In_ PDEBUG_BREAKPOINT breakpoint
    );
  STDMETHOD(Exception)(
    THIS_
    _In_ PEXCEPTION_RECORD64 exception,
    _In_ ULONG first_chance
    );
  STDMETHOD(CreateProcess)(
    THIS_
    _In_ ULONG64 image_file_handle,
    _In_ ULONG64 handle,
    _In_ ULONG64 base_offset,
    _In_ ULONG module_size,
    _In_ PCSTR module_name,
    _In_ PCSTR image_name,
    _In_ ULONG check_sum,
    _In_ ULONG time_data_stamp,
    _In_ ULONG64 initial_thread_handle,
    _In_ ULONG64 thread_data_offset,
    _In_ ULONG64 start_offset    
  );
  STDMETHOD(CreateThread)(
    THIS_
    _In_ ULONG64 Handle,
    _In_ ULONG64 DataOffset,
    _In_ ULONG64 StartOffset
  );
  STDMETHOD(LoadModule)(
    THIS_
    _In_ ULONG64 image_file_handle,
    _In_ ULONG64 base_offset,
    _In_ ULONG module_size,
    _In_ PCSTR module_name,
    _In_ PCSTR image_name,
    _In_ ULONG check_sum,
    _In_ ULONG time_date_stamp
  );
  STDMETHOD(SessionStatus)(
    THIS_
    _In_ ULONG status
  );

 public:
  IDebugControl* m_Control;
  std::ofstream* m_stat_file;
};

#endif  // EVENT_CALLBACKS_H_
